from datetime import datetime
from decimal import Decimal

class AvaMqttOutput:
    """Interface of the application data type AvaMqttOutput.
       Generated by: EASy-Producer."""

    def getXaxis(self) -> str:
        """Returns the value of xaxis.
        Returns:
            str
                the value of xaxis
        """
        raise NotImplementedError

    def getYaxis(self) -> str:
        """Returns the value of yaxis.
        Returns:
            str
                the value of yaxis
        """
        raise NotImplementedError

    def getZaxis(self) -> str:
        """Returns the value of zaxis.
        Returns:
            str
                the value of zaxis
        """
        raise NotImplementedError

    def setXaxis(self, v: str):
        """Changes the value of xaxis.
        Parameters:
            - v (str) -- the new value of xaxis
        """
        raise NotImplementedError

    def setYaxis(self, v: str):
        """Changes the value of yaxis.
        Parameters:
            - v (str) -- the new value of yaxis
        """
        raise NotImplementedError

    def setZaxis(self, v: str):
        """Changes the value of zaxis.
        Parameters:
            - v (str) -- the new value of zaxis
        """
        raise NotImplementedError

    # Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    # backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    # functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    # interfaces become superfluous due to the properties, but let's leave them in for now.
    xaxis = property(getXaxis, setXaxis)
    yaxis = property(getYaxis, setYaxis)
    zaxis = property(getZaxis, setZaxis)

